PhraseQuery (Lucene 3.6.2 API)
Keywords: org.apache.lucene.search.PhraseQuery class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.search
Class PhraseQuery

    java.lang.Object
      org.apache.lucene.search.Query
          org.apache.lucene.search.PhraseQuery

All Implemented Interfaces:
  Serializable, Cloneable

Direct Known Subclasses:
  NGramPhraseQuery

    public class PhraseQuery

extends Query

A Query that matches documents containing a particular sequence of terms. A PhraseQuery is built by QueryParser for input like `"new york"`.

This query may be combined with other terms or queries with a `BooleanQuery`.

See Also:
  Serialized Form

Constructor Summary
`PhraseQuery()` Constructs an empty phrase query.

Method Summary
`void` | `add(Term term)` Adds a term to the end of the query phrase.
`void` | `add(Term term, int position)` Adds a term to the end of the query phrase.
`Weight` | `createWeight(Searcher searcher)` Expert: Constructs an appropriate Weight implementation for this query.
`boolean` | `equals(Object o)` Returns true iff `o` is equal to this.
`void` | `extractTerms(Set<Term> queryTerms)` Expert: adds all terms occurring in this query to the terms set.
`int[]` | `getPositions()` Returns the relative positions of terms in this phrase.
`int` | `getSlop()` Returns the slop.
`Term[]` | `getTerms()` Returns the set of terms in this phrase.
`int` | `hashCode()` Returns a hash code value for this object.
`Query` | `rewrite(IndexReader reader)` Expert: called to re-write queries into primitive queries.
`void` | `setSlop(int s)` Sets the number of other words permitted between words in query phrase.
`String` | `toString(String f)` Prints a user-readable version of this query.

Methods inherited from class org.apache.lucene.search.Query
`clone, combine, getBoost, getSimilarity, mergeBooleanQueries, setBoost, toString, weight`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### PhraseQuery

    public PhraseQuery()

  Constructs an empty phrase query.

Method Detail

### setSlop

    public void setSlop(int s)

  Sets the number of other words permitted between words in query phrase. If zero, then this is an exact phrase search. For larger values this works like a `WITHIN` or `NEAR` operator.

  The slop is in fact an edit-distance, where the units correspond to moves of terms in the query phrase out of position. For example, to switch the order of two words requires two moves (the first move places the words atop one another), so to permit re-orderings of phrases, the slop must be at least two.

  More exact matches are scored higher than sloppier matches, thus search results are sorted by exactness.

  The slop is zero by default, requiring exact matches.

### getSlop

    public int getSlop()

  Returns the slop. See setSlop().

### add

    public void add(Term term)

  Adds a term to the end of the query phrase. The relative position of the term is the one immediately after the last term added.

### add

    public void add(Term term,
                    int position)

  Adds a term to the end of the query phrase. The relative position of the term within the phrase is specified explicitly. This allows e.g. phrases with more than one term at the same position or phrases with gaps (e.g. in connection with stopwords).

  Parameters:
    `term` -
    `position` -

### getTerms

    public Term[] getTerms()

  Returns the set of terms in this phrase.

### getPositions

    public int[] getPositions()

  Returns the relative positions of terms in this phrase.

### rewrite

    public Query rewrite(IndexReader reader)
                  throws IOException

  Description copied from class: `Query`
  Expert: called to re-write queries into primitive queries. For example, a PrefixQuery will be rewritten into a BooleanQuery that consists of TermQuerys.

  Overrides:
    `rewrite` in class `Query`
  Throws:
    `IOException`

### createWeight

    public Weight createWeight(Searcher searcher)
                        throws IOException

  Description copied from class: `Query`
  Expert: Constructs an appropriate Weight implementation for this query.

  Only implemented by primitive queries, which re-write to themselves.

  Overrides:
    `createWeight` in class `Query`
  Throws:
    `IOException`

### extractTerms

    public void extractTerms(Set<Term> queryTerms)

  Description copied from class: `Query`
  Expert: adds all terms occurring in this query to the terms set. Only works if this query is in its `rewritten` form.

  Overrides:
    `extractTerms` in class `Query`
  See Also:
    `Query.extractTerms(Set)`

### toString

    public String toString(String f)

  Prints a user-readable version of this query.

  Specified by:
    `toString` in class `Query`

### equals

    public boolean equals(Object o)

  Returns true iff `o` is equal to this.

  Overrides:
    `equals` in class `Query`

### hashCode

    public int hashCode()

  Returns a hash code value for this object.

  Overrides:
    `hashCode` in class `Query`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD